#define ERRFN_MSE 0
#define ERRFN_POW4 1
#define ERRFN_ITANH 2
#define ERRFN_IATANH1 3
#define ERRFN_IATANH2 4
#define ERRFN_ASYMM1 5
#define ERRFN_ASYMM2 6
#define ERRFN_ASYMML 7
#define SERIALIZED_HDR_SIZE 22

class TNetMaker
{
public:
	TNetMaker(const Char_t* host, Int_t port, Int_t buff_size = 64);
	~TNetMaker();

	void SetAddress(const Char_t* host, Int_t port);
	void SetLocalPort(Int_t port) { fLocalPort = port; }

	Int_t GetBufferLength();
	void SetBufferLength(Int_t length);

	Int_t Send(Float_t* vector_f, Int_t length, Char_t type = ERRFN_MSE);
	Int_t Send(Float_t* vector_f, Int_t inputs, Int_t targets,
		Int_t outputs, Int_t notused, Char_t type = ERRFN_MSE);
	Int_t SendTrigg();

	// Send whole ntuple entries as input vectors.
	Int_t Send(TNtuple* ntuple, Char_t type = ERRFN_MSE);

	// Send only selected variables.
	Int_t Send(TTree* tree, const Char_t* inputs,
		const Char_t* targets = NULL,
		const Char_t* outputs = NULL,
		const Char_t* notused = NULL,
		Char_t type = ERRFN_MSE);

	TNtuple* GetNtuple();

	Int_t Flush();

private:
	Int_t Queue(Char_t* bytes, Int_t length);
	Int_t ParseData(Char_t* buffer, TNtuple** ntuple);

	Char_t* fBuffer;
	Int_t fBufferLength, fBufferSpace, fBufferPos;
	Bool_t fBufferEmpty;

	Char_t* fHostName;
	Int_t fRemotePort;
	Int_t fLocalPort;
	Bool_t fEndOfData;
};
